<script type="text/javascript" src="../../lib/scorecloud.js"></script>

<dom-module id="sc-score-image">
  <template>
    <div id="score-image"></div>
  </template>

  <script>
    Polymer({

      is: 'sc-score-image',
      attached: function () {
        this.scoreImage = new ScoreImage("score-image");
        this.labels = [{},{},{}];
        this.schema = new Schema(3);
        this.score = new Score(3);
      },
      listeners: {
        'track':'track',
        'scaleright':'scaleright',
        'scaleleft':'scaleleft',
        'drag':'drag'
      },
      track: function (e) {
        switch(e.detail.state) {
          case 'start':
            this.gstaff = this.scoreImage.getStaffAt(e.detail.y);
            this.glab = this.gstaff.createGlabOn(e.detail.x)
            this.label =  new Label (toOffset(e.detail.x), 0);
            break;
          case 'track':
            this.glab.resize(e.detail.dx);
            this.label.duration = toOffset(e.detail.dx);
            break;
          case 'end':
            this.glab.setBehavior(this);
            //this.labels[this.gstaff.index][this.glab.id] = this.label;
            this.schema.addLabel(this.gstaff.index, this.glab.id, this.label)
            this.fire('iron-signal', {name: 'debug', data: this.schema.toString()});
            break;
        }
      },
      scaleright: function (e) {
        //var label = getLabel(this.labels, e.detail.id);
        this.schema.getLabel(e.detail.id).duration = toOffset(e.detail.width);
        this.fire('iron-signal', {name: 'debug', data: this.schema.toString()});
      },
      scaleleft: function (e) {
        //var label = getLabel(this.labels, e.detail.id);
        this.schema.getLabel(e.detail.id).duration = toOffset(e.detail.width);
        this.schema.getLabel(e.detail.id).start = toOffset(e.detail.x);
        this.fire('iron-signal', {name: 'debug', data: this.schema.toString()});
      },
      drag: function (e) {
        //var label = getLabel(this.labels, e.detail.id);
        this.schema.getLabel(e.detail.id).start = toOffset(e.detail.x);
        this.fire('iron-signal', {name: 'debug', data: this.schema.toString()});
      }
    });
    </script>
</dom-module>
